% Autor:
% Datum: 10.03.03


% Variablenwert
varWert(_, [], 'undefiniert').
varWert(V, [wert(V, W) | _], W).
varWert(V, [wert(X, _) | R], W) :- V \= X, varWert(V, R, W).

% Neuer Zustand
neuerZustand(V, W, [], [wert(V, W)]).
neuerZustand(V, W, [wert(V, _) | R], [wert(V, W) | R]).
neuerZustand(V, W, [wert(X, WAlt) | R], [wert(X, WAlt) | RNeu]) :-
   V \= X, neuerZustand(V, W, R, RNeu).

% primitive Zuweisung ausfhren
ausfuehren(let(X, Y), ZAlt, ZNeu) :-
  varWert(Y, ZAlt, W), neuerZustand(X, W, ZAlt, ZNeu).
% primitive Zuweisungssequenz ausfhren
ausfuehren([], ZAlt, ZAlt).
ausfuehren([Zuw | R], ZAlt, ZNeu) :-
  ausfuehren(Zuw, ZAlt, Z), ausfuehren(R, Z, ZNeu).



test_varWert(X, W) :-
  varWert(X, [wert(x,2), wert(y,5), wert(z, 7)], W).
  
test_neuerZustand(X, W, Z) :-
  neuerZustand(X, W, [wert(x,2), wert(y,5), wert(z, 7)], Z).

test1_ausfuehren(Z) :-
  ausfuehren(let(z, y), [wert(x,2), wert(y,5), wert(z, 7)], Z).

test2_ausfuehren(Z) :-
  ausfuehren([let(h, y), let(y, z), let(z, h)],
             [wert(x,2), wert(y,5), wert(z, 7)],
             Z).

